/*
 * simulateCost.cpp
 *
 *  Created on: 26 juil. 2017
 *      Author: ddhoutau
 */

#include <iostream>
#include <tclap/CmdLine.h>
#include <map>

using namespace std;

int main(int _argc, char **_argv) {

    int nbNodes;
    float growthRate;
    float errorMargin;
    bool verboseMode;
    int nbNodesMin, nbNodesMax;
    int remainingFreeRounds;

    map<double, int> seuils_gr2_err5;
    seuils_gr2_err5.insert(pair<double,int>(0.00003814697265625,1542));
    seuils_gr2_err5.insert(pair<double,int>(0.0000762939453125,1542));
    seuils_gr2_err5.insert(pair<double,int>(0.000152587890625,1542));
    seuils_gr2_err5.insert(pair<double,int>(0.00030517578125,1542));
    seuils_gr2_err5.insert(pair<double,int>(0.00006103515625,1542));
    seuils_gr2_err5.insert(pair<double,int>(0.0001220703125,1542));
    seuils_gr2_err5.insert(pair<double,int>(0.000244140625,1542));
    seuils_gr2_err5.insert(pair<double,int>(0.0009765625,1542));
    seuils_gr2_err5.insert(pair<double,int>(0.001953125,1540));
    seuils_gr2_err5.insert(pair<double,int>(0.00390625,1535));
    seuils_gr2_err5.insert(pair<double,int>(0.0078125,1530));
    seuils_gr2_err5.insert(pair<double,int>(0.015625,1520));
    seuils_gr2_err5.insert(pair<double,int>(0.03125,1500));
    seuils_gr2_err5.insert(pair<double,int>(0.0625,1450));
    seuils_gr2_err5.insert(pair<double,int>(0.125,1350));
    seuils_gr2_err5.insert(pair<double,int>(0.25,1150));
    seuils_gr2_err5.insert(pair<double,int>(0.5,760));
    seuils_gr2_err5.insert(pair<double,int>(1,-1));

    map<double, int> seuils_gr2_err10;
    seuils_gr2_err10.insert(pair<double,int>(0.00003814697265625,386));
    seuils_gr2_err10.insert(pair<double,int>(0.0000762939453125,386));
    seuils_gr2_err10.insert(pair<double,int>(0.000152587890625,386));
    seuils_gr2_err10.insert(pair<double,int>(0.00030517578125,386));
    seuils_gr2_err10.insert(pair<double,int>(0.00006103515625,386));
    seuils_gr2_err10.insert(pair<double,int>(0.0001220703125,386));
    seuils_gr2_err10.insert(pair<double,int>(0.000244140625,386));
    seuils_gr2_err10.insert(pair<double,int>(0.0009765625,386));
    seuils_gr2_err10.insert(pair<double,int>(0.001953125,386));
    seuils_gr2_err10.insert(pair<double,int>(0.00390625,385));
    seuils_gr2_err10.insert(pair<double,int>(0.0078125,384));
    seuils_gr2_err10.insert(pair<double,int>(0.015625,380));
    seuils_gr2_err10.insert(pair<double,int>(0.03125,375));
    seuils_gr2_err10.insert(pair<double,int>(0.0625,362));
    seuils_gr2_err10.insert(pair<double,int>(0.125,338));
    seuils_gr2_err10.insert(pair<double,int>(0.25,288));
    seuils_gr2_err10.insert(pair<double,int>(0.5,190));
    seuils_gr2_err10.insert(pair<double,int>(1,-1));

    map<double, int> seuils_gr16_err10;

    seuils_gr16_err10.insert(pair<double,int>(0.00000308148791101958, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.00000493038065763132, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.00000788860905221012, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.0000126217744835362, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.0000201948391736579, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.0000323117426778526, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.0000516987882845642, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.0000827180612553028, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.000132348898008, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.000211758236814, 387));

    seuils_gr16_err10.insert(pair<double,int>(0.000338813178902, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.000542101086243, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.000867361737988, 387));
    seuils_gr16_err10.insert(pair<double,int>(0.0013877788, 386));
    seuils_gr16_err10.insert(pair<double,int>(0.002220446, 386));
    seuils_gr16_err10.insert(pair<double,int>(0.0035527137, 385));
    seuils_gr16_err10.insert(pair<double,int>(0.0056843419, 384));
    seuils_gr16_err10.insert(pair<double,int>(0.009094947, 383 ));
    seuils_gr16_err10.insert(pair<double,int>(0.0145519152, 381));
    seuils_gr16_err10.insert(pair<double,int>(0.0232830644, 377));
    seuils_gr16_err10.insert(pair<double,int>(0.037252903, 372));
    seuils_gr16_err10.insert(pair<double,int>(0.0596046448, 364));
    seuils_gr16_err10.insert(pair<double,int>(0.0953674316, 350));
    seuils_gr16_err10.insert(pair<double,int>(0.1525878906, 327));
    seuils_gr16_err10.insert(pair<double,int>(0.244140625, 291 ));
    seuils_gr16_err10.insert(pair<double,int>(0.390625, 235));
    seuils_gr16_err10.insert(pair<double,int>(0.625, 139));
    seuils_gr16_err10.insert(pair<double,int>(1, -1));

    map<double, int> seuils_gr16_err5;

    seuils_gr16_err5.insert(pair<double,int>(0.00000308148791101958, 1548));
    seuils_gr16_err5.insert(pair<double,int>(0.00000493038065763132, 1548));
    seuils_gr16_err5.insert(pair<double,int>(0.00000788860905221012, 1548));
    seuils_gr16_err5.insert(pair<double,int>(0.0000126217744835362, 1548));
    seuils_gr16_err5.insert(pair<double,int>(0.0000201948391736579, 1457));
    seuils_gr16_err5.insert(pair<double,int>(0.0000323117426778526, 1547));
    seuils_gr16_err5.insert(pair<double,int>(0.0000516987882845642, 1546));
    seuils_gr16_err5.insert(pair<double,int>(0.0000827180612553028, 1546));
    seuils_gr16_err5.insert(pair<double,int>(0.000132348898008, 1546));
    seuils_gr16_err5.insert(pair<double,int>(0.000211758236814, 1546));

    seuils_gr16_err5.insert(pair<double,int>(0.000338813178902, 1546));
    seuils_gr16_err5.insert(pair<double,int>(0.000542101086243, 1545));
    seuils_gr16_err5.insert(pair<double,int>(0.000867361737988, 1545));
    seuils_gr16_err5.insert(pair<double,int>(0.0013877788, 1545));
    seuils_gr16_err5.insert(pair<double,int>(0.002220446, 1544));
    seuils_gr16_err5.insert(pair<double,int>(0.0035527137, 1544));
    seuils_gr16_err5.insert(pair<double,int>(0.0056843419, 1543));
    seuils_gr16_err5.insert(pair<double,int>(0.009094947, 1542 ));
    seuils_gr16_err5.insert(pair<double,int>(0.0145519152, 1540));
    seuils_gr16_err5.insert(pair<double,int>(0.0232830644, 1535));
    seuils_gr16_err5.insert(pair<double,int>(0.037252903, 1530));
    seuils_gr16_err5.insert(pair<double,int>(0.0596046448, 1520));
    seuils_gr16_err5.insert(pair<double,int>(0.0953674316, 1500));
    seuils_gr16_err5.insert(pair<double,int>(0.1525878906, 1450));
    seuils_gr16_err5.insert(pair<double,int>(0.244140625, 1342 ));
    seuils_gr16_err5.insert(pair<double,int>(0.390625, 1150));
    seuils_gr16_err5.insert(pair<double,int>(0.625, 760));
    seuils_gr16_err5.insert(pair<double,int>(1, -1));

    map<double, int> seuils;

    try {
        TCLAP::CmdLine cmd("simulateCost", ' ', "1.0");
        TCLAP::ValueArg<int> nbNodesParam("n", "nbNodes", "nombre de noeuds", false, 1000, "int");
        TCLAP::ValueArg<int> nbNodesMinParam("", "nMin", "nombre de noeuds minimum", false, -1, "int");
        TCLAP::ValueArg<int> nbNodesMaxParam("", "nMax", "nombre de noeuds maximum", false, -1, "int");
        TCLAP::ValueArg<int> rfrParam("", "rfr", "nombre de rounds supplémentaires", false, 0, "int");
        TCLAP::ValueArg<float> growthRateParam("g", "growthRate", "growth rate (possible values: 1.2, 1.6, 2", false, 2, "float");
        TCLAP::ValueArg<float> errorMarginParam("e", "errorMargin", "error margin (possible values: 5, 10", false, 10, "float");
        TCLAP::SwitchArg verboseModeParam("v", "verbose", "display rounds informations", cmd, false);

        cmd.add(nbNodesParam);
        cmd.add(nbNodesMinParam);
        cmd.add(nbNodesMaxParam);
        cmd.add(rfrParam);
        cmd.add(growthRateParam);
        cmd.add(errorMarginParam);

        cmd.parse( _argc, _argv );

        nbNodes = nbNodesParam.getValue();
        nbNodesMin = nbNodesMinParam.getValue();
        nbNodesMax = nbNodesMaxParam.getValue();
        remainingFreeRounds = rfrParam.getValue();
        growthRate = growthRateParam.getValue();
        errorMargin = errorMarginParam.getValue();
        verboseMode = verboseModeParam.getValue();
    } catch (TCLAP::ArgException &e) {
        cerr << "*** ERROR *** " << e.error() << " for arg " << e.argId() << std::endl;
    }

    if ( verboseMode ) {
        cout << "growthRate:          " << growthRate << endl;
        cout << "errorMargin:         " << errorMargin << endl;
        cout << "nbNodes:             " << nbNodes << endl;
        cout << "nbNodesMin:          " << nbNodesMin << endl;
        cout << "nbNodesMax:          " << nbNodesMax << endl;
        cout << "remainingFreeRounds: " << remainingFreeRounds << endl;
    }

    if ( nbNodesMin == -1 || nbNodesMax == -1 ) {
        nbNodesMin = nbNodes;
        nbNodesMax = nbNodes;
    }

    if ( growthRate == 2 && errorMargin == 10 ) { seuils = seuils_gr2_err10; }
    else if ( growthRate == 2 && errorMargin == 5 ) { seuils = seuils_gr2_err5; }
    else if ( growthRate == 16 && errorMargin == 10 ) { seuils = seuils_gr16_err10; }
    else if ( growthRate == 16 && errorMargin == 5 ) { seuils = seuils_gr16_err5; }
    else {
        cout << "*** ERROR, invalid values or combination of values for growthRate and errorMargin" << endl;
        exit(EXIT_FAILURE);
    }

    map<double,int>::iterator it = seuils.begin();
    bool goodEstimationFound = false;

    double totalPacketsSent = 0;
    double packetsSentThisRound;
    int round = 1;
    bool previousRoundNotOk = true;
    int rfr;

    //double totalPacketsSentPreviousRound = 100000000;

    nbNodes = nbNodesMin;
    while ( nbNodes <= nbNodesMax ) {
        goodEstimationFound = false;
        totalPacketsSent = 0;
        round = 1;
        previousRoundNotOk = true;
        it = seuils.begin();
        rfr = remainingFreeRounds + 1;

        while ( !goodEstimationFound ) {
            packetsSentThisRound = nbNodes * it->first;

            if ( packetsSentThisRound < it->second || previousRoundNotOk || rfr > 0) {
                totalPacketsSent += packetsSentThisRound;
                if ( verboseMode ) {
                    cout << "round: " << round << " prob: " << it->first << " threshold: " << it->second << " packets sent: " << packetsSentThisRound << " rfr: " << rfr << endl;
                }
            }
            if ( packetsSentThisRound > it->second ) {
                previousRoundNotOk = false;
            }
            if ( !previousRoundNotOk && rfr > 0) {
                rfr--;
            }
            it++;
            round++;
            if (it == seuils.end()) {
                goodEstimationFound = true;
            }
        }

        if ( verboseMode ) {
            cout << "total packets sent: " << totalPacketsSent << endl;
        } else {
            cout << nbNodes << " " << totalPacketsSent << endl;
//            if (totalPacketsSent < totalPacketsSentPreviousRound) {
//                //cout << nbNodes << " " << totalPacketsSent << endl;
//                cout << nbNodes-1 << " " << totalPacketsSentPreviousRound << endl;
//            }
//            totalPacketsSentPreviousRound = totalPacketsSent;
        }
        nbNodes++;
    }
}


