clear
reset
#set key off
set border 3

# Add a vertical dotted line at x=0 to show centre (mean) of distribution.
set yzeroaxis

# Each bar is half the (visual) width of its x-range.
set boxwidth 0.1 absolute
set style fill solid 1.0 noborder

bin_width = 0.001;

bin_number(x) = floor(x/bin_width)

rounded(x) = bin_width * ( bin_number(x) + 0.5 )

#replace column number accordingly:
# 1 : real number of neighbours
# 2 : estimated number of neighbours
# 3 : (real - estimated) number of neighbours
# 4 : (real / estimated) number of neighbours

#example: plot 'log.histo' using (rounded($3)):(3) smooth frequency with boxes

plot 'log.histo' using (rounded($1)):(1) smooth frequency with boxes

#plot 'estimationErrorHisto-tic02-g2.txt' using (rounded($1)):(1) smooth frequency with boxes,\
#'estimationErrorHisto-tic05-g2.txt' using (rounded($1)):(1) smooth frequency with boxes,\
#'estimationErrorHisto-tic15-g2.txt' using (rounded($1)):(1) smooth frequency with boxes,\
#'estimationErrorHisto-tic30-g2.txt' using (rounded($1)):(1) smooth frequency with boxes

#plot 'estimationErrorHisto-tic02-g3.txt' using (rounded($1)):(1) smooth frequency with boxes,\
#'estimationErrorHisto-tic05-g3.txt' using (rounded($1)):(1) smooth frequency with boxes,\
#'estimationErrorHisto-tic15-g3.txt' using (rounded($1)):(1) smooth frequency with boxes,\
#'estimationErrorHisto-tic30-g3.txt' using (rounded($1)):(1) smooth frequency with boxes