/*
 * testCollision.cpp
 *
 *  Created on: 19 avr. 2017
 *      Author: ddhoutau
 */

#include <iostream>
#include <tclap/CmdLine.h>

using namespace std;

long gcd(long _m, long _n)
{
	long m = _m;
	long n = _n;
	long count = 0;
	long tmp;
        while(m) {
        	cout << m << endl;
        	count++;
        	tmp = m; m = n % m; n = tmp;

        }
        cout << "  pgcd(" << _m << ", " << _n << ") calculé en " << count << " etapes : " << n << endl;
        return n;
}

long lcm(long m, long n)
{
        return m / gcd(m, n) * n;
}

//class Packet {
//public:
//    int id;
//
//    Packet(int _id) { id = _id; };
//    virtual ~Packet() {}
//    virtual void printName() { cout << "Packet " << id << endl; }
//    virtual Packet *clone() {
//        Packet *clone = new Packet(id);
//        return(clone);
//    }
//
//};
//
//class DomPacket : public Packet {
//public:
//    string message;
//    DomPacket(int _id, string _m) : Packet(_id) { message = _m;};
//    virtual ~DomPacket() {}
//    virtual void printName() { cout << "DomPacket " << id << " message: " << message << endl; }
//    virtual DomPacket *clone() {
//        DomPacket *clone = new DomPacket(id, message);
//        return(clone);
//    }
//};
//
//typedef shared_ptr<Packet> PacketPtr;
//typedef shared_ptr<DomPacket> DomPacketPtr;

int main(int _argc, char **_argv) {

//    PacketPtr p1 = PacketPtr(new Packet(1));
//    PacketPtr p2 = PacketPtr(new DomPacket(2, "toto"));
//    p1->printName();
//    p2->printName();
//
//    PacketPtr p3 = PacketPtr(p1->clone());
//    p3->printName();
//    PacketPtr p4 = PacketPtr(p2->clone());
//    p4->printName();


    cout << "==============" << endl;

	long beta1, beta2;
	long tp;
	long ts1, ts2;
	long dateDebut1, dateDebut2;
	long offset;

    try {
        TCLAP::CmdLine cmd("testCollision", ' ', "1.0");
        TCLAP::ValueArg<int> beta1Param("", "beta1", "beta paquet considéré", false, 1000, "int");
        TCLAP::ValueArg<int> beta2Param("", "beta2", "beta paquet parasite", false, 1000, "int");
        TCLAP::ValueArg<int> tpParam("", "tp", "durée des pulse", false, 100, "int");
        TCLAP::ValueArg<int> dateDebut1Param("", "debut1", "date de début du paquet considéré", false, 0, "int");
        TCLAP::ValueArg<int> dateDebut2Param("", "debut2", "date de début du paquet parasite", false, 0, "int");

        cmd.add(beta1Param);
        cmd.add(beta2Param);
        cmd.add(tpParam);
        cmd.add(dateDebut1Param);
        cmd.add(dateDebut2Param);
        cmd.parse( _argc, _argv );

        beta1 = beta1Param.getValue();
        beta2 = beta2Param.getValue();
        dateDebut1 = dateDebut1Param.getValue();
        dateDebut2 = dateDebut2Param.getValue();
        tp = tpParam.getValue();

    } catch (TCLAP::ArgException &e) {
        cerr << "*** ERROR *** " << e.error() << " for arg " << e.argId() << std::endl;
    }

    ts1 = tp * beta1;
    ts2 = tp * beta2;
    offset = dateDebut1 - dateDebut2;

    cout << "testCollision v1.0" << endl;
    cout << endl;
    cout << "Beta1:                     " << beta1 << endl;
    cout << "Beta2:                     " << beta2 << endl;
    cout << "tp:                        " << tp << endl;
    cout << "dateDebut1:                " << dateDebut1 << endl;
    cout << "dateDebut2:                " << dateDebut2 << endl;
    cout << endl;
    cout << "ts1:                       " << ts1 << endl;
    cout << "ts2:                       " << ts2 << endl;
    cout << "offset:                    " << offset << endl;
    cout << endl;

    long pgcdTs = gcd(ts1, ts2);
    long ppcmTs = lcm(ts1, ts2);

    cout << endl;
    cout << "offset % pgcdTs: " << offset % pgcdTs << endl;
    long diff;
    diff = ((offset % pgcdTs) + pgcdTs) % pgcdTs;
    cout << "diff: " << diff << endl;

    cout << endl;

    if ( diff < tp || diff > (pgcdTs-tp)) {
    	cout << "Il y a collision quelque part" << endl;
    	cout << " Les collisions ont lieu tous les " << ppcmTs << endl;
    	cout << "soit au pire dans " << ppcmTs / ts1 << " bits du paquet considéré" << endl;
    	cout << "soit au pire dans " << ppcmTs / ts2 << " bits du paquet parasite" << endl;
    } else {
    	cout << "Il n'y a jamais collision" << endl;
    }

    cout << endl << endl;

    cout << ((dateDebut1 - dateDebut2) % ts1) << endl;
    cout << (((dateDebut1 - dateDebut2) % ts1) + ts1) %ts1 << endl;
}

