/*
 * testProba.cpp
 *
 *  Created on: 30 juin 2017
 *      Author: ddhoutau
 */

/*
 * testCollision.cpp
 *
 *  Created on: 19 avr. 2017
 *      Author: ddhoutau
 */

#include <math.h>
#include <iostream>
#include <fstream>
#include <gmpxx.h>

#include <tclap/CmdLine.h>

using namespace std;

long gcd(long _m, long _n)
{
    long m = _m;
    long n = _n;
    long count = 0;
    long tmp;
        while(m) {
            cout << m << endl;
            count++;
            tmp = m; m = n % m; n = tmp;

        }
        cout << "  pgcd(" << _m << ", " << _n << ") calculé en " << count << " etapes : " << n << endl;
        return n;
}

long lcm(long m, long n)
{
        return m / gcd(m, n) * n;
}

//class Packet {
//public:
//    int id;
//
//    Packet(int _id) { id = _id; };
//    virtual ~Packet() {}
//    virtual void printName() { cout << "Packet " << id << endl; }
//    virtual Packet *clone() {
//        Packet *clone = new Packet(id);
//        return(clone);
//    }
//
//};
//
//class DomPacket : public Packet {
//public:
//    string message;
//    DomPacket(int _id, string _m) : Packet(_id) { message = _m;};
//    virtual ~DomPacket() {}
//    virtual void printName() { cout << "DomPacket " << id << " message: " << message << endl; }
//    virtual DomPacket *clone() {
//        DomPacket *clone = new DomPacket(id, message);
//        return(clone);
//    }
//};
//
//typedef shared_ptr<Packet> PacketPtr;
//typedef shared_ptr<DomPacket> DomPacketPtr;

double coeffBinomial(double n, double p) {
    if (p<0 || p>n) {
        return(0);
    }
    if (p>n/2) {
        return(coeffBinomial(n, n-p));
    } else {
        double c=1;
        for (int k=1; k<=p; k++) {
            c = c*(n+1-k)/k;
        }
        return(c);
    }
}

mpf_class coeffBinomialMP(mpf_class n, mpf_class p) {
    if (p<0 || p>n) {
        return(0);
    }

//    cout << n << " " << p << endl;

    if (p>n/2) {
        return(coeffBinomialMP(n, n-p));
    } else {
        mpf_class c=1;
        for (int k=1; k<=p; k++) {
            c = c*(n+1-k)/k;
        }
        return(c);
    }
}

double f(double n, double p, double k) {
    double coeff = coeffBinomial(n,k);
    double pow1 = pow(p,k);
    double pow2 = pow(1-p, n-k);

    double res = coeff * pow1 * pow2;

//    cout << "coeff: " << coeff << endl;
//    cout << "pow(p,k): " << pow1 << endl;
//    cout << "pow(1-p,n-k): " << pow2 << endl;
//    cout << "res: " << res << endl;

    return(res);
    //return(coeffBinomial(n,k)*pow(p,k)*pow(1-p, n-k));
}

mpf_class fMP(unsigned long n, mpf_class p, unsigned long k) {
    mpf_class pow1MP, pow2MP;
    mpf_class t3 = 1 - p;

//    mpf_class coeffMP = coeffBinomialMP(n,k);
//    mpf_pow_ui(pow1MP.get_mpf_t(), p.get_mpf_t(), k);
//    mpf_pow_ui(pow2MP.get_mpf_t(), t3.get_mpf_t(), n-k);

    mpz_t coeffMPz;
    mpz_init_set_ui(coeffMPz,0);
    mpz_bin_uiui(coeffMPz, n ,k);
    mpf_t coeffMPf;
    mpf_init(coeffMPf);
    mpf_set_z(coeffMPf, coeffMPz);

    mpf_class coeffMP(coeffMPf);
    mpf_pow_ui(pow1MP.get_mpf_t(), p.get_mpf_t(), k);
    mpf_pow_ui(pow2MP.get_mpf_t(), t3.get_mpf_t(), n-k);

    mpf_class resMP = coeffMP * pow1MP * pow2MP;

//    cout << "coeffMP: " << coeffMP << endl;
//    cout << "powMP(p,k): " << pow1MP << endl;
//    cout << "powMP(1-p,n-k): " << pow2MP << endl;
//    cout << "resMP: " << resMP << endl;

    return(resMP);
}

mpf_class pascalMP(unsigned long n, mpf_class p, unsigned long k) {
    mpf_class pow1MP, pow2MP;
    mpf_class t3 = 1 - p;
    mpf_class coeffMP = coeffBinomialMP(n-1, n-k);
    
    mpf_pow_ui(pow1MP.get_mpf_t(), p.get_mpf_t(), k);
    mpf_pow_ui(pow2MP.get_mpf_t(), t3.get_mpf_t(), n-k);
    
    mpf_class resMP = coeffMP * pow1MP * pow2MP;
    return(resMP);
}

int main(int _argc, char **_argv) {

//    PacketPtr p1 = PacketPtr(new Packet(1));
//    PacketPtr p2 = PacketPtr(new DomPacket(2, "toto"));
//    p1->printName();
//    p2->printName();
//
//    PacketPtr p3 = PacketPtr(p1->clone());
//    p3->printName();
//    PacketPtr p4 = PacketPtr(p2->clone());
//    p4->printName();


//    cout << "==============" << endl;

    unsigned int n,k;
    double p;
    unsigned int plusProbable;
    unsigned int borneInf5, borneSup5;
    unsigned int borneInf10, borneSup10;
    unsigned int borneInf15, borneSup15;
    unsigned int borneInf20, borneSup20;
    unsigned int borneInf40, borneSup40;
    unsigned int borneInf60, borneSup60;
    unsigned int nbTics;

    bool multiPrecision;

    try {
        TCLAP::CmdLine cmd("testCollision", ' ', "1.0");
        TCLAP::ValueArg<double> pParam("", "prob", "probabilité", false, 0.1, "double");
        TCLAP::ValueArg<unsigned int> nParam("", "num", "n.", false, 1000, "unsigned int");
        TCLAP::ValueArg<unsigned int> kParam("", "observed", "observed", false, 1000, "unsigned int");
        TCLAP::ValueArg<unsigned int> ticParam("", "tics", "nombre de tics", false, 1, "unsigned int");
        TCLAP::SwitchArg multiPrecisionParam("","mp", "calcul en mode multi-précision", cmd, false);

        cmd.add(pParam);
        cmd.add(nParam);
        cmd.add(kParam);
        cmd.add(ticParam);
        cmd.parse( _argc, _argv );

        p = pParam.getValue();
        n = nParam.getValue();
        k = kParam.getValue();
        nbTics = ticParam.getValue();
        multiPrecision = multiPrecisionParam.getValue();

    } catch (TCLAP::ArgException &e) {
        cerr << "*** ERROR *** " << e.error() << " for arg " << e.argId() << std::endl;
    }

//    cout << endl << endl;
//
    plusProbable = (k/(double)nbTics) / p;
    borneInf5 = plusProbable - plusProbable*0.025;
    borneSup5 = plusProbable + plusProbable*0.025;

    borneInf10 = plusProbable - plusProbable*0.05;
    borneSup10 = plusProbable + plusProbable*0.05;

    borneInf15 = plusProbable - plusProbable*0.075;
    borneSup15 = plusProbable + plusProbable*0.075;

    borneInf20 = plusProbable - plusProbable*0.1;
    borneSup20 = plusProbable + plusProbable*0.1;

    borneInf40 = plusProbable - plusProbable*0.2;
    borneSup40 = plusProbable + plusProbable*0.2;

    borneInf60 = plusProbable - plusProbable*0.3;
    borneSup60 = plusProbable + plusProbable*0.3;



    cout << "n: " << n << endl;
    cout << "k: " << k << endl;
    cout << "p: " << p << endl;
    cout << "nbTics: " << nbTics << endl;
    cout << "plusProbable: " << plusProbable << endl;
    cout << "interval +-  2.5%: [ " << borneInf5 << " , " << borneSup5 << " ]" << endl;
    cout << "interval +-  5.0%: [ " << borneInf10 << " , " << borneSup10 << " ]" << endl;
    cout << "interval +-  7.5%: [ " << borneInf15 << " , " << borneSup15 << " ]" << endl;
    cout << "interval +- 10.0%: [ " << borneInf20 << " , " << borneSup20 << " ]" << endl;
    cout << "interval +- 20.0%: [ " << borneInf40 << " , " << borneSup40 << " ]" << endl;
    cout << "interval +- 30.0%: [ " << borneInf60 << " , " << borneSup60 << " ]" << endl;

//    for (double k=0; k<n; k++) {
//        cout << k << "  " << f(n,p,k) << endl;
//    }

//    f(7000,p,k);
//    fMP(7000,p,k);

    std::ofstream fileOutput;
    fileOutput.open("toto.txt");

    if (!multiPrecision) {
        double res = 0;
        double somme = 0;
        double sommeInterval5 = 0;
        double sommeInterval10 = 0;
        double sommeInterval15 = 0;

        //unsigned int maxN = 3*k/p;
        unsigned int nDiv;

        //for (n=0; n<maxN; n++) {
        n = k;
       // k=k*nbTics;
        double maxSomme = (1/p)*0.9999;

        while (somme < maxSomme /*&& n <maxN*/) {
            res = f(n,p,k);
            //if (n%10==0)
                fileOutput << n/nbTics << " " << res << endl;
            //cout << n << " " << resMP << endl;
            somme += res;

            nDiv = n / nbTics;
            if (nDiv >= borneInf5 && nDiv <= borneSup5) sommeInterval5 += res;
            if (nDiv >= borneInf10 && nDiv <= borneSup10) sommeInterval10 += res;
            if (nDiv >= borneInf15 && nDiv <= borneSup15) sommeInterval15 += res;

            n++;
        }
        cout << "sommeMP: " << somme << endl;
        cout << "sommeInterval5: " << sommeInterval5 << " ( " << 100/(somme/sommeInterval5)<< "% )" <<  endl;
        cout << "sommeInterval10: " << sommeInterval10 << " ( " << 100/(somme/sommeInterval10)<< "% )" <<  endl;
        cout << "sommeInterval15: " << sommeInterval15 << " ( " << 100/(somme/sommeInterval15)<< "% )" <<  endl;
    } else {
        mpf_class resMP = 0;
        mpf_class sommeMP = 0;
        mpf_class sommeInterval5MP = 0;
        mpf_class sommeInterval10MP = 0;
        mpf_class sommeInterval15MP = 0;
        mpf_class sommeInterval20MP = 0;
        mpf_class sommeInterval40MP = 0;
        mpf_class sommeInterval60MP = 0;
        
        mpf_class resPascalMP = 0;

        //unsigned int maxN = 3*k/p;
        unsigned int nDiv;

        //for (n=0; n<maxN; n++) {
        n = k;
       // k=k*nbTics;
        mpf_class maxSomme = (1/p)*0.99999;

        while (sommeMP < maxSomme /*&& n <maxN*/) {
            resMP = fMP(n,p,k);
            //resPascalMP = pascalMP(n,p,k);
            //if (n%10==0)
            //fileOutput << n/nbTics << " " << resMP << " " << resPascalMP << endl;
            fileOutput << n/nbTics << " " << resMP << endl;
            //cout << n << " " << resMP << endl;
            sommeMP += resMP;

            nDiv = n / nbTics;
            if (nDiv >= borneInf5 && nDiv <= borneSup5) sommeInterval5MP += resMP;
            if (nDiv >= borneInf10 && nDiv <= borneSup10) sommeInterval10MP += resMP;
            if (nDiv >= borneInf15 && nDiv <= borneSup15) sommeInterval15MP += resMP;
            if (nDiv >= borneInf20 && nDiv <= borneSup20) sommeInterval20MP += resMP;
            if (nDiv >= borneInf40 && nDiv <= borneSup40) sommeInterval40MP += resMP;
            if (nDiv >= borneInf60 && nDiv <= borneSup60) sommeInterval60MP += resMP;

            n++;
        }
        cout << "sommeMP: " << sommeMP << endl;
        cout << "sommeInterval5MP: " << sommeInterval5MP << " ( " << 100/(sommeMP/sommeInterval5MP)<< "% )" <<  endl;
        cout << "sommeInterval10MP: " << sommeInterval10MP << " ( " << 100/(sommeMP/sommeInterval10MP)<< "% )" <<  endl;
        cout << "sommeInterval15MP: " << sommeInterval15MP << " ( " << 100/(sommeMP/sommeInterval15MP)<< "% )" <<  endl;
        cout << "sommeInterval20MP: " << sommeInterval20MP << " ( " << 100/(sommeMP/sommeInterval20MP)<< "% )" <<  endl;
        cout << "sommeInterval40MP: " << sommeInterval40MP << " ( " << 100/(sommeMP/sommeInterval40MP)<< "% )" <<  endl;
        cout << "sommeInterval60MP: " << sommeInterval60MP << " ( " << 100/(sommeMP/sommeInterval60MP)<< "% )" <<  endl;
}


    fileOutput.close();


    string cmd = "gnuplot -e \"";
    cmd += "set arrow from "+to_string(borneInf5)+", graph 0 to "+to_string(borneInf5)+",graph 1 nohead lc 2;";
    cmd += "set arrow from "+to_string(borneSup5)+", graph 0 to "+to_string(borneSup5)+",graph 1 nohead lc 2;";

    cmd += "set arrow from "+to_string(borneInf10)+", graph 0 to "+to_string(borneInf10)+",graph 1 nohead lc 3;";
    cmd += "set arrow from "+to_string(borneSup10)+", graph 0 to "+to_string(borneSup10)+",graph 1 nohead lc 3;";

    cmd += "set arrow from "+to_string(borneInf15)+", graph 0 to "+to_string(borneInf15)+",graph 1 nohead lc 4;";
    cmd += "set arrow from "+to_string(borneSup15)+", graph 0 to "+to_string(borneSup15)+",graph 1 nohead lc 4;";

    cmd += "set arrow from "+to_string(borneInf20)+", graph 0 to "+to_string(borneInf20)+",graph 1 nohead lc 5;";
    cmd += "set arrow from "+to_string(borneSup20)+", graph 0 to "+to_string(borneSup20)+",graph 1 nohead lc 5;";

    cmd += "set arrow from "+to_string(borneInf40)+", graph 0 to "+to_string(borneInf40)+",graph 1 nohead lc 6;";
    cmd += "set arrow from "+to_string(borneSup40)+", graph 0 to "+to_string(borneSup40)+",graph 1 nohead lc 6;";

    cmd += "set arrow from "+to_string(borneInf60)+", graph 0 to "+to_string(borneInf60)+",graph 1 nohead lc 7;";
    cmd += "set arrow from "+to_string(borneSup60)+", graph 0 to "+to_string(borneSup60)+",graph 1 nohead lc 7;";

    cmd +=" plot 'toto.txt' with line title 'p:"+to_string(p)+" observed:"+to_string(k)+" nbTics:"+to_string(nbTics)+"'\"";
    //system("gnuplot -e \"plot 'toto.txt' with line\"");
    //system(cmd.c_str());

}




